' **********************************************************************
'
' Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
'
' This copy of Ice is licensed to you under the terms described in the
' ICE_LICENSE file included in this distribution.
'
' **********************************************************************

' Ice version 3.2.1
' Generated from file `matt.ice'

Imports _System = System
Imports _Microsoft = Microsoft

Namespace matt

    Public Class MattException
        Inherits Ice.UserException

#Region "Slice data members"

        Public description As String

#End Region

#Region "Constructors"

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal ex__ As _System.Exception)
            MyBase.New(ex__)
        End Sub

        Private Sub initDM__(ByVal description As String)
            Me.description = description
        End Sub

        Public Sub New(ByVal description As String)
            initDM__(description)
        End Sub

        Public Sub New(ByVal description As String, ByVal ex__ As _System.Exception)
            MyBase.New(ex__)
            initDM__(description)
        End Sub

#End Region

#Region "Object members"

        Public Overrides Function GetHashCode() As Integer
            Dim h__ As Integer = 0
            If Not description Is Nothing Then
                h__ = 5 * h__ + description.GetHashCode()
            End If
            Return h__
        End Function

        Public Overloads Overrides Function Equals(ByVal other__ As Object) As Boolean
            If other__ Is Nothing Then
                Return False
            End If
            If Object.ReferenceEquals(Me, other__) Then
                Return True
            End If
            If Not TypeOf other__ Is MattException Then
                Return False
            End If
            If description Is Nothing Then
                If Not (CType(other__, MattException)).description Is Nothing
                    Return False
                End If
            Else
                If Not description.Equals(CType(other__, MattException).description) Then
                    Return False
                End If
            End If
            Return True
        End Function

#End Region

#Region "Marshaling support"

        Public Overloads Overrides Sub write__(ByVal os__ As IceInternal.BasicStream)
            os__.writeString("::matt::MattException")
            os__.startWriteSlice()
            os__.writeString(description)
            os__.endWriteSlice()
        End Sub

        Public Overloads Overrides Sub read__(ByVal is__ As IceInternal.BasicStream, ByVal rid__ As Boolean)
            If rid__ Then
                Dim myId As String = is__.readString()
            End If
            is__.startReadSlice()
            description = is__.readString()
            is__.endReadSlice()
        End Sub

        Public Overloads Overrides Sub write__(ByVal outS__ As Ice.OutputStream)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattException was not generated with stream support"
            Throw ex
        End Sub

        Public Overloads Overrides Sub read__(ByVal inS__ As Ice.InputStream, ByVal rid__ As Boolean)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattException was not generated with stream support"
            Throw ex
        End Sub

        Public Overrides Function usesClasses__() As Boolean
            Return True
        End Function

#End Region

    End Class

    Public Class MattNotActiveException
        Inherits matt.MattException

#Region "Constructors"

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal ex__ As _System.Exception)
            MyBase.New(ex__)
        End Sub

        Public Sub New(ByVal description As String)
            MyBase.New(description)
        End Sub

        Public Sub New(ByVal description As String, ByVal ex__ As _System.Exception)
            MyBase.New(description, ex__)
        End Sub

#End Region

#Region "Object members"

        Public Overrides Function GetHashCode() As Integer
            Dim h__ As Integer = 0
            Return h__
        End Function

        Public Overloads Overrides Function Equals(ByVal other__ As Object) As Boolean
            If other__ Is Nothing Then
                Return False
            End If
            If Object.ReferenceEquals(Me, other__) Then
                Return True
            End If
            If Not TypeOf other__ Is MattNotActiveException Then
                Return False
            End If
            Return True
        End Function

#End Region

#Region "Marshaling support"

        Public Overloads Overrides Sub write__(ByVal os__ As IceInternal.BasicStream)
            os__.writeString("::matt::MattNotActiveException")
            os__.startWriteSlice()
            os__.endWriteSlice()
            MyBase.write__(os__)
        End Sub

        Public Overloads Overrides Sub read__(ByVal is__ As IceInternal.BasicStream, ByVal rid__ As Boolean)
            If rid__ Then
                Dim myId As String = is__.readString()
            End If
            is__.startReadSlice()
            is__.endReadSlice()
            MyBase.read__(is__, true)
        End Sub

        Public Overloads Overrides Sub write__(ByVal outS__ As Ice.OutputStream)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattNotActiveException was not generated with stream support"
            Throw ex
        End Sub

        Public Overloads Overrides Sub read__(ByVal inS__ As Ice.InputStream, ByVal rid__ As Boolean)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattNotActiveException was not generated with stream support"
            Throw ex
        End Sub

        Public Overrides Function usesClasses__() As Boolean
            Return True
        End Function

#End Region

    End Class

    Public Class MattNoMessageException
        Inherits matt.MattException

#Region "Constructors"

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal ex__ As _System.Exception)
            MyBase.New(ex__)
        End Sub

        Public Sub New(ByVal description As String)
            MyBase.New(description)
        End Sub

        Public Sub New(ByVal description As String, ByVal ex__ As _System.Exception)
            MyBase.New(description, ex__)
        End Sub

#End Region

#Region "Object members"

        Public Overrides Function GetHashCode() As Integer
            Dim h__ As Integer = 0
            Return h__
        End Function

        Public Overloads Overrides Function Equals(ByVal other__ As Object) As Boolean
            If other__ Is Nothing Then
                Return False
            End If
            If Object.ReferenceEquals(Me, other__) Then
                Return True
            End If
            If Not TypeOf other__ Is MattNoMessageException Then
                Return False
            End If
            Return True
        End Function

#End Region

#Region "Marshaling support"

        Public Overloads Overrides Sub write__(ByVal os__ As IceInternal.BasicStream)
            os__.writeString("::matt::MattNoMessageException")
            os__.startWriteSlice()
            os__.endWriteSlice()
            MyBase.write__(os__)
        End Sub

        Public Overloads Overrides Sub read__(ByVal is__ As IceInternal.BasicStream, ByVal rid__ As Boolean)
            If rid__ Then
                Dim myId As String = is__.readString()
            End If
            is__.startReadSlice()
            is__.endReadSlice()
            MyBase.read__(is__, true)
        End Sub

        Public Overloads Overrides Sub write__(ByVal outS__ As Ice.OutputStream)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattNoMessageException was not generated with stream support"
            Throw ex
        End Sub

        Public Overloads Overrides Sub read__(ByVal inS__ As Ice.InputStream, ByVal rid__ As Boolean)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattNoMessageException was not generated with stream support"
            Throw ex
        End Sub

        Public Overrides Function usesClasses__() As Boolean
            Return True
        End Function

#End Region

    End Class

    Public Class MattListenException
        Inherits matt.MattException

#Region "Constructors"

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal ex__ As _System.Exception)
            MyBase.New(ex__)
        End Sub

        Public Sub New(ByVal description As String)
            MyBase.New(description)
        End Sub

        Public Sub New(ByVal description As String, ByVal ex__ As _System.Exception)
            MyBase.New(description, ex__)
        End Sub

#End Region

#Region "Object members"

        Public Overrides Function GetHashCode() As Integer
            Dim h__ As Integer = 0
            Return h__
        End Function

        Public Overloads Overrides Function Equals(ByVal other__ As Object) As Boolean
            If other__ Is Nothing Then
                Return False
            End If
            If Object.ReferenceEquals(Me, other__) Then
                Return True
            End If
            If Not TypeOf other__ Is MattListenException Then
                Return False
            End If
            Return True
        End Function

#End Region

#Region "Marshaling support"

        Public Overloads Overrides Sub write__(ByVal os__ As IceInternal.BasicStream)
            os__.writeString("::matt::MattListenException")
            os__.startWriteSlice()
            os__.endWriteSlice()
            MyBase.write__(os__)
        End Sub

        Public Overloads Overrides Sub read__(ByVal is__ As IceInternal.BasicStream, ByVal rid__ As Boolean)
            If rid__ Then
                Dim myId As String = is__.readString()
            End If
            is__.startReadSlice()
            is__.endReadSlice()
            MyBase.read__(is__, true)
        End Sub

        Public Overloads Overrides Sub write__(ByVal outS__ As Ice.OutputStream)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattListenException was not generated with stream support"
            Throw ex
        End Sub

        Public Overloads Overrides Sub read__(ByVal inS__ As Ice.InputStream, ByVal rid__ As Boolean)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattListenException was not generated with stream support"
            Throw ex
        End Sub

        Public Overrides Function usesClasses__() As Boolean
            Return True
        End Function

#End Region

    End Class

    Public Class MattAlreadyListeningException
        Inherits matt.MattListenException

#Region "Constructors"

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal ex__ As _System.Exception)
            MyBase.New(ex__)
        End Sub

        Public Sub New(ByVal description As String)
            MyBase.New(description)
        End Sub

        Public Sub New(ByVal description As String, ByVal ex__ As _System.Exception)
            MyBase.New(description, ex__)
        End Sub

#End Region

#Region "Object members"

        Public Overrides Function GetHashCode() As Integer
            Dim h__ As Integer = 0
            Return h__
        End Function

        Public Overloads Overrides Function Equals(ByVal other__ As Object) As Boolean
            If other__ Is Nothing Then
                Return False
            End If
            If Object.ReferenceEquals(Me, other__) Then
                Return True
            End If
            If Not TypeOf other__ Is MattAlreadyListeningException Then
                Return False
            End If
            Return True
        End Function

#End Region

#Region "Marshaling support"

        Public Overloads Overrides Sub write__(ByVal os__ As IceInternal.BasicStream)
            os__.writeString("::matt::MattAlreadyListeningException")
            os__.startWriteSlice()
            os__.endWriteSlice()
            MyBase.write__(os__)
        End Sub

        Public Overloads Overrides Sub read__(ByVal is__ As IceInternal.BasicStream, ByVal rid__ As Boolean)
            If rid__ Then
                Dim myId As String = is__.readString()
            End If
            is__.startReadSlice()
            is__.endReadSlice()
            MyBase.read__(is__, true)
        End Sub

        Public Overloads Overrides Sub write__(ByVal outS__ As Ice.OutputStream)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattAlreadyListeningException was not generated with stream support"
            Throw ex
        End Sub

        Public Overloads Overrides Sub read__(ByVal inS__ As Ice.InputStream, ByVal rid__ As Boolean)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattAlreadyListeningException was not generated with stream support"
            Throw ex
        End Sub

        Public Overrides Function usesClasses__() As Boolean
            Return True
        End Function

#End Region

    End Class

    Public Class MattNotListeningException
        Inherits matt.MattListenException

#Region "Constructors"

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal ex__ As _System.Exception)
            MyBase.New(ex__)
        End Sub

        Public Sub New(ByVal description As String)
            MyBase.New(description)
        End Sub

        Public Sub New(ByVal description As String, ByVal ex__ As _System.Exception)
            MyBase.New(description, ex__)
        End Sub

#End Region

#Region "Object members"

        Public Overrides Function GetHashCode() As Integer
            Dim h__ As Integer = 0
            Return h__
        End Function

        Public Overloads Overrides Function Equals(ByVal other__ As Object) As Boolean
            If other__ Is Nothing Then
                Return False
            End If
            If Object.ReferenceEquals(Me, other__) Then
                Return True
            End If
            If Not TypeOf other__ Is MattNotListeningException Then
                Return False
            End If
            Return True
        End Function

#End Region

#Region "Marshaling support"

        Public Overloads Overrides Sub write__(ByVal os__ As IceInternal.BasicStream)
            os__.writeString("::matt::MattNotListeningException")
            os__.startWriteSlice()
            os__.endWriteSlice()
            MyBase.write__(os__)
        End Sub

        Public Overloads Overrides Sub read__(ByVal is__ As IceInternal.BasicStream, ByVal rid__ As Boolean)
            If rid__ Then
                Dim myId As String = is__.readString()
            End If
            is__.startReadSlice()
            is__.endReadSlice()
            MyBase.read__(is__, true)
        End Sub

        Public Overloads Overrides Sub write__(ByVal outS__ As Ice.OutputStream)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattNotListeningException was not generated with stream support"
            Throw ex
        End Sub

        Public Overloads Overrides Sub read__(ByVal inS__ As Ice.InputStream, ByVal rid__ As Boolean)
            Dim ex As Ice.MarshalException = New Ice.MarshalException
            ex.reason = "type matt::MattNotListeningException was not generated with stream support"
            Throw ex
        End Sub

        Public Overrides Function usesClasses__() As Boolean
            Return True
        End Function

#End Region

    End Class

    Namespace messaging

        Public Enum EventType
            Message
            Closed
        End Enum

        Public MustInherit Class EventListener
            Inherits Ice.ObjectImpl
            Implements EventListenerOperations_, EventListenerOperationsNC_

#Region "Slice operations"

            Public Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String) Implements EventListenerOperationsNC_.onEvent
                onEvent([event], message, Ice.ObjectImpl.defaultCurrent)
            End Sub

            Public MustOverride Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String, ByVal current__ As Ice.Current) Implements EventListenerOperations_.onEvent

#End Region

#Region "Slice type-related members"

            Public Shared Shadows ids__ As String() = New String() _
                { _
                    "::Ice::Object", _
                    "::matt::messaging::EventListener" _
                }

            Public Overloads Overrides Function ice_isA(ByVal s As String) As Boolean
                Return _System.Array.BinarySearch(ids__, s, _System.Collections.Comparer.DefaultInvariant) >= 0
            End Function

            Public Overloads Overrides Function ice_isA(ByVal s As String, Byval current__ As Ice.Current) As Boolean
                Return _System.Array.BinarySearch(ids__, s, _System.Collections.Comparer.DefaultInvariant) >= 0
            End Function

            Public Overloads Overrides Function ice_ids() As String()
                Return ids__
            End Function

            Public Overloads Overrides Function ice_ids(ByVal current__ As Ice.Current) As String()
                Return ids__
            End Function

            Public Overloads Overrides Function ice_id() As String
                Return ids__(1)
            End Function

            Public Overloads Overrides Function ice_id(ByVal current__ As Ice.Current) As String
                Return ids__(1)
            End Function

            Public Overloads Shared Function ice_staticId() As String
                Return ids__(1)
            End Function

#End Region

#Region "Operation dispatch"

            Public Shared Function onEvent___( _
                    ByVal obj__ As EventListenerOperations_, _
                    ByVal inS__ As IceInternal.Incoming, _
                    ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                checkMode__(Ice.OperationMode.Normal, current__.mode)
                Dim is__ As IceInternal.BasicStream = inS__.istr()
                Dim [event] As matt.messaging.EventType = Nothing
                [event] = CType(is__.readByte(), matt.messaging.EventType)
                Dim message As String = Nothing
                message = is__.readString()
                obj__.onEvent([event], message, current__)
                Return IceInternal.DispatchStatus.DispatchOK
            End Function

            Public Shared Shadows all__ As String() = New String() _
                { _
                    "ice_id", _
                    "ice_ids", _
                    "ice_isA", _
                    "ice_ping", _
                    "onEvent" _
                }

            Public Overloads Overrides Function dispatch__( _
                    ByVal inS__ As IceInternal.Incoming, _
                    ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                Dim pos As Integer
                pos = _System.Array.BinarySearch(all__, current__.operation, _System.Collections.Comparer.DefaultInvariant)
                If pos < 0 Then
                    Return IceInternal.DispatchStatus.DispatchOperationNotExist
                End If
                Select Case pos
                    Case 0
                        Return ice_id___(Me, inS__, current__)
                    Case 1
                        Return ice_ids___(Me, inS__, current__)
                    Case 2
                        Return ice_isA___(Me, inS__, current__)
                    Case 3
                        Return ice_ping___(Me, inS__, current__)
                    Case 4
                        Return onEvent___(Me, inS__, current__)
                End Select

                ' _System.Diagnostics.Debug.Assert(false) ' Bug in VB 7.1: Diagnostics.Debug is not found
                Return IceInternal.DispatchStatus.DispatchOperationNotExist
            End Function

#End Region

#Region "Marshaling support"

            Public Overloads Overrides Sub write__(ByVal os__ As IceInternal.BasicStream)
                os__.writeTypeId(ice_staticId())
                os__.startWriteSlice()
                os__.endWriteSlice()
                MyBase.write__(os__)
            End Sub

            Public Overloads Overrides Sub read__(ByVal is__ As IceInternal.BasicStream, ByVal rid__ As Boolean)
                If rid__ Then
                    Dim myId As String = is__.readTypeId()
                End If
                is__.startReadSlice()
                is__.endReadSlice()
                MyBase.read__(is__, true)
            End Sub

            Public Overloads Overrides Sub write__(ByVal outS__ As Ice.OutputStream)
                Dim ex As Ice.MarshalException = New Ice.MarshalException
                ex.reason = "type matt::messaging::EventListener was not generated with stream support"
                Throw ex
            End Sub

            Public Overloads Overrides Sub read__(ByVal inS__ As Ice.InputStream, ByVal rid__ As Boolean)
                Dim ex As Ice.MarshalException = New Ice.MarshalException
                ex.reason = "type matt::messaging::EventListener was not generated with stream support"
                Throw ex
            End Sub

#End Region
        End Class

        Public MustInherit Class Mailbox
            Inherits Ice.ObjectImpl
            Implements MailboxOperations_, MailboxOperationsNC_

#Region "Slice operations"

            Public Function empty() As Boolean Implements MailboxOperationsNC_.empty
                Return empty(Ice.ObjectImpl.defaultCurrent)
            End Function

            Public MustOverride Function empty(ByVal current__ As Ice.Current) As Boolean Implements MailboxOperations_.empty

            Public Function active() As Boolean Implements MailboxOperationsNC_.active
                Return active(Ice.ObjectImpl.defaultCurrent)
            End Function

            Public MustOverride Function active(ByVal current__ As Ice.Current) As Boolean Implements MailboxOperations_.active

            Public Function read() As String Implements MailboxOperationsNC_.read
                Return read(Ice.ObjectImpl.defaultCurrent)
            End Function

            Public MustOverride Function read(ByVal current__ As Ice.Current) As String Implements MailboxOperations_.read

            Public Sub write(ByVal message As String) Implements MailboxOperationsNC_.write
                write(message, Ice.ObjectImpl.defaultCurrent)
            End Sub

            Public MustOverride Sub write(ByVal message As String, ByVal current__ As Ice.Current) Implements MailboxOperations_.write

            Public Sub addListener(ByVal listener As matt.messaging.EventListenerPrx) Implements MailboxOperationsNC_.addListener
                addListener(listener, Ice.ObjectImpl.defaultCurrent)
            End Sub

            Public MustOverride Sub addListener(ByVal listener As matt.messaging.EventListenerPrx, ByVal current__ As Ice.Current) Implements MailboxOperations_.addListener

            Public Sub removeListener() Implements MailboxOperationsNC_.removeListener
                removeListener(Ice.ObjectImpl.defaultCurrent)
            End Sub

            Public MustOverride Sub removeListener(ByVal current__ As Ice.Current) Implements MailboxOperations_.removeListener

#End Region

#Region "Slice type-related members"

            Public Shared Shadows ids__ As String() = New String() _
                { _
                    "::Ice::Object", _
                    "::matt::messaging::Mailbox" _
                }

            Public Overloads Overrides Function ice_isA(ByVal s As String) As Boolean
                Return _System.Array.BinarySearch(ids__, s, _System.Collections.Comparer.DefaultInvariant) >= 0
            End Function

            Public Overloads Overrides Function ice_isA(ByVal s As String, Byval current__ As Ice.Current) As Boolean
                Return _System.Array.BinarySearch(ids__, s, _System.Collections.Comparer.DefaultInvariant) >= 0
            End Function

            Public Overloads Overrides Function ice_ids() As String()
                Return ids__
            End Function

            Public Overloads Overrides Function ice_ids(ByVal current__ As Ice.Current) As String()
                Return ids__
            End Function

            Public Overloads Overrides Function ice_id() As String
                Return ids__(1)
            End Function

            Public Overloads Overrides Function ice_id(ByVal current__ As Ice.Current) As String
                Return ids__(1)
            End Function

            Public Overloads Shared Function ice_staticId() As String
                Return ids__(1)
            End Function

#End Region

#Region "Operation dispatch"

            Public Shared Function empty___( _
                    ByVal obj__ As MailboxOperations_, _
                    ByVal inS__ As IceInternal.Incoming, _
                    ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                checkMode__(Ice.OperationMode.Normal, current__.mode)
                Dim os__ As IceInternal.BasicStream = inS__.ostr()
                Dim ret__ As Boolean = obj__.empty(current__)
                os__.writeBool(ret__)
                Return IceInternal.DispatchStatus.DispatchOK
            End Function

            Public Shared Function active___( _
                    ByVal obj__ As MailboxOperations_, _
                    ByVal inS__ As IceInternal.Incoming, _
                    ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                checkMode__(Ice.OperationMode.Normal, current__.mode)
                Dim os__ As IceInternal.BasicStream = inS__.ostr()
                Dim ret__ As Boolean = obj__.active(current__)
                os__.writeBool(ret__)
                Return IceInternal.DispatchStatus.DispatchOK
            End Function

            Public Shared Function read___( _
                    ByVal obj__ As MailboxOperations_, _
                    ByVal inS__ As IceInternal.Incoming, _
                    ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                checkMode__(Ice.OperationMode.Normal, current__.mode)
                Dim os__ As IceInternal.BasicStream = inS__.ostr()
                Try
                    Dim ret__ As String = obj__.read(current__)
                    os__.writeString(ret__)
                    Return IceInternal.DispatchStatus.DispatchOK
                Catch ex As matt.MattNoMessageException
                    os__.writeUserException(ex)
                    Return IceInternal.DispatchStatus.DispatchUserException
                    Catch ex As matt.MattNotActiveException
                        os__.writeUserException(ex)
                        Return IceInternal.DispatchStatus.DispatchUserException
                    End Try
                End Function

                Public Shared Function write___( _
                        ByVal obj__ As MailboxOperations_, _
                        ByVal inS__ As IceInternal.Incoming, _
                        ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                    checkMode__(Ice.OperationMode.Normal, current__.mode)
                    Dim is__ As IceInternal.BasicStream = inS__.istr()
                    Dim os__ As IceInternal.BasicStream = inS__.ostr()
                    Dim message As String = Nothing
                    message = is__.readString()
                    Try
                        obj__.write(message, current__)
                        Return IceInternal.DispatchStatus.DispatchOK
                    Catch ex As matt.MattNotActiveException
                        os__.writeUserException(ex)
                        Return IceInternal.DispatchStatus.DispatchUserException
                    End Try
                End Function

                Public Shared Function addListener___( _
                        ByVal obj__ As MailboxOperations_, _
                        ByVal inS__ As IceInternal.Incoming, _
                        ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                    checkMode__(Ice.OperationMode.Normal, current__.mode)
                    Dim is__ As IceInternal.BasicStream = inS__.istr()
                    Dim os__ As IceInternal.BasicStream = inS__.ostr()
                    Dim listener As matt.messaging.EventListenerPrx = Nothing
                    listener = matt.messaging.EventListenerPrxHelper.read__(is__)
                    Try
                        obj__.addListener(listener, current__)
                        Return IceInternal.DispatchStatus.DispatchOK
                    Catch ex As matt.MattAlreadyListeningException
                        os__.writeUserException(ex)
                        Return IceInternal.DispatchStatus.DispatchUserException
                        Catch ex As matt.MattListenException
                            os__.writeUserException(ex)
                            Return IceInternal.DispatchStatus.DispatchUserException
                            Catch ex As matt.MattNotActiveException
                                os__.writeUserException(ex)
                                Return IceInternal.DispatchStatus.DispatchUserException
                            End Try
                        End Function

                        Public Shared Function removeListener___( _
                                ByVal obj__ As MailboxOperations_, _
                                ByVal inS__ As IceInternal.Incoming, _
                                ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                            checkMode__(Ice.OperationMode.Normal, current__.mode)
                            Dim os__ As IceInternal.BasicStream = inS__.ostr()
                            Try
                                obj__.removeListener(current__)
                                Return IceInternal.DispatchStatus.DispatchOK
                            Catch ex As matt.MattNotListeningException
                                os__.writeUserException(ex)
                                Return IceInternal.DispatchStatus.DispatchUserException
                                Catch ex As matt.MattListenException
                                    os__.writeUserException(ex)
                                    Return IceInternal.DispatchStatus.DispatchUserException
                                    Catch ex As matt.MattNotActiveException
                                        os__.writeUserException(ex)
                                        Return IceInternal.DispatchStatus.DispatchUserException
                                    End Try
                                End Function

                                Public Shared Shadows all__ As String() = New String() _
                                    { _
                                        "active", _
                                        "addListener", _
                                        "empty", _
                                        "ice_id", _
                                        "ice_ids", _
                                        "ice_isA", _
                                        "ice_ping", _
                                        "read", _
                                        "removeListener", _
                                        "write" _
                                    }

                                Public Overloads Overrides Function dispatch__( _
                                        ByVal inS__ As IceInternal.Incoming, _
                                        ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                                    Dim pos As Integer
                                    pos = _System.Array.BinarySearch(all__, current__.operation, _System.Collections.Comparer.DefaultInvariant)
                                    If pos < 0 Then
                                        Return IceInternal.DispatchStatus.DispatchOperationNotExist
                                    End If
                                    Select Case pos
                                        Case 0
                                            Return active___(Me, inS__, current__)
                                        Case 1
                                            Return addListener___(Me, inS__, current__)
                                        Case 2
                                            Return empty___(Me, inS__, current__)
                                        Case 3
                                            Return ice_id___(Me, inS__, current__)
                                        Case 4
                                            Return ice_ids___(Me, inS__, current__)
                                        Case 5
                                            Return ice_isA___(Me, inS__, current__)
                                        Case 6
                                            Return ice_ping___(Me, inS__, current__)
                                        Case 7
                                            Return read___(Me, inS__, current__)
                                        Case 8
                                            Return removeListener___(Me, inS__, current__)
                                        Case 9
                                            Return write___(Me, inS__, current__)
                                    End Select

                                    ' _System.Diagnostics.Debug.Assert(false) ' Bug in VB 7.1: Diagnostics.Debug is not found
                                    Return IceInternal.DispatchStatus.DispatchOperationNotExist
                                End Function

#End Region

#Region "Marshaling support"

                                Public Overloads Overrides Sub write__(ByVal os__ As IceInternal.BasicStream)
                                    os__.writeTypeId(ice_staticId())
                                    os__.startWriteSlice()
                                    os__.endWriteSlice()
                                    MyBase.write__(os__)
                                End Sub

                                Public Overloads Overrides Sub read__(ByVal is__ As IceInternal.BasicStream, ByVal rid__ As Boolean)
                                    If rid__ Then
                                        Dim myId As String = is__.readTypeId()
                                    End If
                                    is__.startReadSlice()
                                    is__.endReadSlice()
                                    MyBase.read__(is__, true)
                                End Sub

                                Public Overloads Overrides Sub write__(ByVal outS__ As Ice.OutputStream)
                                    Dim ex As Ice.MarshalException = New Ice.MarshalException
                                    ex.reason = "type matt::messaging::Mailbox was not generated with stream support"
                                    Throw ex
                                End Sub

                                Public Overloads Overrides Sub read__(ByVal inS__ As Ice.InputStream, ByVal rid__ As Boolean)
                                    Dim ex As Ice.MarshalException = New Ice.MarshalException
                                    ex.reason = "type matt::messaging::Mailbox was not generated with stream support"
                                    Throw ex
                                End Sub

#End Region
                            End Class

                        End Namespace

                        Namespace roles

                            Public MustInherit Class Participant
                                Inherits Ice.ObjectImpl
                                Implements ParticipantOperations_, ParticipantOperationsNC_

#Region "Slice operations"

                                Public Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx) Implements ParticipantOperationsNC_.setMailbox
                                    setMailbox(mb, Ice.ObjectImpl.defaultCurrent)
                                End Sub

                                Public MustOverride Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx, ByVal current__ As Ice.Current) Implements ParticipantOperations_.setMailbox

#End Region

#Region "Slice type-related members"

                                Public Shared Shadows ids__ As String() = New String() _
                                    { _
                                        "::Ice::Object", _
                                        "::matt::roles::Participant" _
                                    }

                                Public Overloads Overrides Function ice_isA(ByVal s As String) As Boolean
                                    Return _System.Array.BinarySearch(ids__, s, _System.Collections.Comparer.DefaultInvariant) >= 0
                                End Function

                                Public Overloads Overrides Function ice_isA(ByVal s As String, Byval current__ As Ice.Current) As Boolean
                                    Return _System.Array.BinarySearch(ids__, s, _System.Collections.Comparer.DefaultInvariant) >= 0
                                End Function

                                Public Overloads Overrides Function ice_ids() As String()
                                    Return ids__
                                End Function

                                Public Overloads Overrides Function ice_ids(ByVal current__ As Ice.Current) As String()
                                    Return ids__
                                End Function

                                Public Overloads Overrides Function ice_id() As String
                                    Return ids__(1)
                                End Function

                                Public Overloads Overrides Function ice_id(ByVal current__ As Ice.Current) As String
                                    Return ids__(1)
                                End Function

                                Public Overloads Shared Function ice_staticId() As String
                                    Return ids__(1)
                                End Function

#End Region

#Region "Operation dispatch"

                                Public Shared Function setMailbox___( _
                                        ByVal obj__ As ParticipantOperations_, _
                                        ByVal inS__ As IceInternal.Incoming, _
                                        ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                                    checkMode__(Ice.OperationMode.Normal, current__.mode)
                                    Dim is__ As IceInternal.BasicStream = inS__.istr()
                                    Dim mb As matt.messaging.MailboxPrx = Nothing
                                    mb = matt.messaging.MailboxPrxHelper.read__(is__)
                                    obj__.setMailbox(mb, current__)
                                    Return IceInternal.DispatchStatus.DispatchOK
                                End Function

                                Public Shared Shadows all__ As String() = New String() _
                                    { _
                                        "ice_id", _
                                        "ice_ids", _
                                        "ice_isA", _
                                        "ice_ping", _
                                        "setMailbox" _
                                    }

                                Public Overloads Overrides Function dispatch__( _
                                        ByVal inS__ As IceInternal.Incoming, _
                                        ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                                    Dim pos As Integer
                                    pos = _System.Array.BinarySearch(all__, current__.operation, _System.Collections.Comparer.DefaultInvariant)
                                    If pos < 0 Then
                                        Return IceInternal.DispatchStatus.DispatchOperationNotExist
                                    End If
                                    Select Case pos
                                        Case 0
                                            Return ice_id___(Me, inS__, current__)
                                        Case 1
                                            Return ice_ids___(Me, inS__, current__)
                                        Case 2
                                            Return ice_isA___(Me, inS__, current__)
                                        Case 3
                                            Return ice_ping___(Me, inS__, current__)
                                        Case 4
                                            Return setMailbox___(Me, inS__, current__)
                                    End Select

                                    ' _System.Diagnostics.Debug.Assert(false) ' Bug in VB 7.1: Diagnostics.Debug is not found
                                    Return IceInternal.DispatchStatus.DispatchOperationNotExist
                                End Function

#End Region

#Region "Marshaling support"

                                Public Overloads Overrides Sub write__(ByVal os__ As IceInternal.BasicStream)
                                    os__.writeTypeId(ice_staticId())
                                    os__.startWriteSlice()
                                    os__.endWriteSlice()
                                    MyBase.write__(os__)
                                End Sub

                                Public Overloads Overrides Sub read__(ByVal is__ As IceInternal.BasicStream, ByVal rid__ As Boolean)
                                    If rid__ Then
                                        Dim myId As String = is__.readTypeId()
                                    End If
                                    is__.startReadSlice()
                                    is__.endReadSlice()
                                    MyBase.read__(is__, true)
                                End Sub

                                Public Overloads Overrides Sub write__(ByVal outS__ As Ice.OutputStream)
                                    Dim ex As Ice.MarshalException = New Ice.MarshalException
                                    ex.reason = "type matt::roles::Participant was not generated with stream support"
                                    Throw ex
                                End Sub

                                Public Overloads Overrides Sub read__(ByVal inS__ As Ice.InputStream, ByVal rid__ As Boolean)
                                    Dim ex As Ice.MarshalException = New Ice.MarshalException
                                    ex.reason = "type matt::roles::Participant was not generated with stream support"
                                    Throw ex
                                End Sub

#End Region
                            End Class

                            Public MustInherit Class Mediator
                                Inherits Ice.ObjectImpl
                                Implements MediatorOperations_, MediatorOperationsNC_

#Region "Slice operations"

                                Public Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx) Implements MediatorOperationsNC_.registerParticipant
                                    registerParticipant(p, Ice.ObjectImpl.defaultCurrent)
                                End Sub

                                Public MustOverride Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx, ByVal current__ As Ice.Current) Implements MediatorOperations_.registerParticipant

#End Region

#Region "Slice type-related members"

                                Public Shared Shadows ids__ As String() = New String() _
                                    { _
                                        "::Ice::Object", _
                                        "::matt::roles::Mediator" _
                                    }

                                Public Overloads Overrides Function ice_isA(ByVal s As String) As Boolean
                                    Return _System.Array.BinarySearch(ids__, s, _System.Collections.Comparer.DefaultInvariant) >= 0
                                End Function

                                Public Overloads Overrides Function ice_isA(ByVal s As String, Byval current__ As Ice.Current) As Boolean
                                    Return _System.Array.BinarySearch(ids__, s, _System.Collections.Comparer.DefaultInvariant) >= 0
                                End Function

                                Public Overloads Overrides Function ice_ids() As String()
                                    Return ids__
                                End Function

                                Public Overloads Overrides Function ice_ids(ByVal current__ As Ice.Current) As String()
                                    Return ids__
                                End Function

                                Public Overloads Overrides Function ice_id() As String
                                    Return ids__(1)
                                End Function

                                Public Overloads Overrides Function ice_id(ByVal current__ As Ice.Current) As String
                                    Return ids__(1)
                                End Function

                                Public Overloads Shared Function ice_staticId() As String
                                    Return ids__(1)
                                End Function

#End Region

#Region "Operation dispatch"

                                Public Shared Function registerParticipant___( _
                                        ByVal obj__ As MediatorOperations_, _
                                        ByVal inS__ As IceInternal.Incoming, _
                                        ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                                    checkMode__(Ice.OperationMode.Normal, current__.mode)
                                    Dim is__ As IceInternal.BasicStream = inS__.istr()
                                    Dim p As matt.roles.ParticipantPrx = Nothing
                                    p = matt.roles.ParticipantPrxHelper.read__(is__)
                                    obj__.registerParticipant(p, current__)
                                    Return IceInternal.DispatchStatus.DispatchOK
                                End Function

                                Public Shared Shadows all__ As String() = New String() _
                                    { _
                                        "ice_id", _
                                        "ice_ids", _
                                        "ice_isA", _
                                        "ice_ping", _
                                        "registerParticipant" _
                                    }

                                Public Overloads Overrides Function dispatch__( _
                                        ByVal inS__ As IceInternal.Incoming, _
                                        ByVal current__ As Ice.Current) As IceInternal.DispatchStatus
                                    Dim pos As Integer
                                    pos = _System.Array.BinarySearch(all__, current__.operation, _System.Collections.Comparer.DefaultInvariant)
                                    If pos < 0 Then
                                        Return IceInternal.DispatchStatus.DispatchOperationNotExist
                                    End If
                                    Select Case pos
                                        Case 0
                                            Return ice_id___(Me, inS__, current__)
                                        Case 1
                                            Return ice_ids___(Me, inS__, current__)
                                        Case 2
                                            Return ice_isA___(Me, inS__, current__)
                                        Case 3
                                            Return ice_ping___(Me, inS__, current__)
                                        Case 4
                                            Return registerParticipant___(Me, inS__, current__)
                                    End Select

                                    ' _System.Diagnostics.Debug.Assert(false) ' Bug in VB 7.1: Diagnostics.Debug is not found
                                    Return IceInternal.DispatchStatus.DispatchOperationNotExist
                                End Function

#End Region

#Region "Marshaling support"

                                Public Overloads Overrides Sub write__(ByVal os__ As IceInternal.BasicStream)
                                    os__.writeTypeId(ice_staticId())
                                    os__.startWriteSlice()
                                    os__.endWriteSlice()
                                    MyBase.write__(os__)
                                End Sub

                                Public Overloads Overrides Sub read__(ByVal is__ As IceInternal.BasicStream, ByVal rid__ As Boolean)
                                    If rid__ Then
                                        Dim myId As String = is__.readTypeId()
                                    End If
                                    is__.startReadSlice()
                                    is__.endReadSlice()
                                    MyBase.read__(is__, true)
                                End Sub

                                Public Overloads Overrides Sub write__(ByVal outS__ As Ice.OutputStream)
                                    Dim ex As Ice.MarshalException = New Ice.MarshalException
                                    ex.reason = "type matt::roles::Mediator was not generated with stream support"
                                    Throw ex
                                End Sub

                                Public Overloads Overrides Sub read__(ByVal inS__ As Ice.InputStream, ByVal rid__ As Boolean)
                                    Dim ex As Ice.MarshalException = New Ice.MarshalException
                                    ex.reason = "type matt::roles::Mediator was not generated with stream support"
                                    Throw ex
                                End Sub

#End Region
                            End Class

                        End Namespace

                    End Namespace

                    Namespace matt

                        Namespace messaging

                            Public Interface EventListenerPrx
                                Inherits Ice.ObjectPrx

                                Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String)
                                Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String, ByVal context__ As Ice.Context)

                            End Interface

                            Public Interface MailboxPrx
                                Inherits Ice.ObjectPrx

                                Function empty() As Boolean
                                Function empty(ByVal context__ As Ice.Context) As Boolean

                                Function active() As Boolean
                                Function active(ByVal context__ As Ice.Context) As Boolean

                                Function read() As String
                                Function read(ByVal context__ As Ice.Context) As String

                                Sub write(ByVal message As String)
                                Sub write(ByVal message As String, ByVal context__ As Ice.Context)

                                Sub addListener(ByVal listener As matt.messaging.EventListenerPrx)
                                Sub addListener(ByVal listener As matt.messaging.EventListenerPrx, ByVal context__ As Ice.Context)

                                Sub removeListener()
                                Sub removeListener(ByVal context__ As Ice.Context)

                            End Interface

                        End Namespace

                        Namespace roles

                            Public Interface ParticipantPrx
                                Inherits Ice.ObjectPrx

                                Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx)
                                Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx, ByVal context__ As Ice.Context)

                            End Interface

                            Public Interface MediatorPrx
                                Inherits Ice.ObjectPrx

                                Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx)
                                Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx, ByVal context__ As Ice.Context)

                            End Interface

                        End Namespace

                    End Namespace

                    Namespace matt

                        Namespace messaging

                            Public Interface EventListenerOperations_

                                Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String, ByVal current__ As Ice.Current)

                            End Interface

                            Public Interface EventListenerOperationsNC_

                                Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String)

                            End Interface

                            Public Interface MailboxOperations_

                                Function empty(ByVal current__ As Ice.Current) As Boolean

                                Function active(ByVal current__ As Ice.Current) As Boolean

                                Function read(ByVal current__ As Ice.Current) As String

                                Sub write(ByVal message As String, ByVal current__ As Ice.Current)

                                Sub addListener(ByVal listener As matt.messaging.EventListenerPrx, ByVal current__ As Ice.Current)

                                Sub removeListener(ByVal current__ As Ice.Current)

                            End Interface

                            Public Interface MailboxOperationsNC_

                                Function empty() As Boolean

                                Function active() As Boolean

                                Function read() As String

                                Sub write(ByVal message As String)

                                Sub addListener(ByVal listener As matt.messaging.EventListenerPrx)

                                Sub removeListener()

                            End Interface

                        End Namespace

                        Namespace roles

                            Public Interface ParticipantOperations_

                                Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx, ByVal current__ As Ice.Current)

                            End Interface

                            Public Interface ParticipantOperationsNC_

                                Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx)

                            End Interface

                            Public Interface MediatorOperations_

                                Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx, ByVal current__ As Ice.Current)

                            End Interface

                            Public Interface MediatorOperationsNC_

                                Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx)

                            End Interface

                        End Namespace

                    End Namespace

                    Namespace matt

                        Namespace messaging

                            Public NotInheritable Class EventListenerPrxHelper
                                Inherits Ice.ObjectPrxHelperBase
                                Implements EventListenerPrx

#Region "Synchronous operations"

                                Public Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String) Implements EventListenerPrx.onEvent
                                    onEvent([event], message, Nothing, False)
                                End Sub

                                Public Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String, ByVal context__ As Ice.Context) Implements EventListenerPrx.onEvent
                                    onEvent([event], message, context__, True)
                                End Sub

                                Private Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String, ByVal context__ As Ice.Context, explicitContext__ As Boolean)
                                    If explicitContext__ And context__ Is Nothing Then
                                        context__ = emptyContext_
                                    End If
                                    Dim cnt__ As Integer = 0
                                    While True
                                        Dim delBase__ As Ice.ObjectDel_ = Nothing
                                        Try
                                            delBase__ = getDelegate__()
                                            Dim del__ As _EventListenerDel = CType(delBase__, _EventListenerDel)
                                            del__.onEvent([event], message, context__)
                                            Return
                                        Catch ex__ As IceInternal.LocalExceptionWrapper
                                            handleExceptionWrapper__(delBase__, ex__)
                                        Catch ex__ As Ice.LocalException
                                            cnt__ = handleException__(delBase__, ex__, cnt__)
                                        End Try
                                    End While
                                End Sub

#End Region

#Region "Checked and unchecked cast operations"

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx) As EventListenerPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    If TypeOf b Is EventListenerPrx Then
                                        Return CType(b, EventListenerPrx)
                                    End If
                                    If b.ice_isA("::matt::messaging::EventListener") Then
                                        Dim h As EventListenerPrxHelper = New EventListenerPrxHelper
                                        h.copyFrom__(b)
                                        Return h
                                    End If
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal ctx As Ice.Context) As EventListenerPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    If TypeOf b Is EventListenerPrx Then
                                        Return CType(b, EventListenerPrx)
                                    End If
                                    If b.ice_isA("::matt::messaging::EventListener", ctx) Then
                                        Dim h As EventListenerPrxHelper = New EventListenerPrxHelper
                                        h.copyFrom__(b)
                                        Return h
                                    End If
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal f As String) As EventListenerPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Try
                                        If bb.ice_isA("::matt::messaging::EventListener") Then
                                            Dim h As EventListenerPrxHelper = new EventListenerPrxHelper()
                                            h.copyFrom__(bb)
                                            Return h
                                        End If
                                    Catch ex__ As Ice.FacetNotExistException
                                    End Try
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal f As String, ByVal ctx As Ice.Context) As EventListenerPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Try
                                        If bb.ice_isA("::matt::messaging::EventListener", ctx) Then
                                            Dim h As EventListenerPrxHelper = new EventListenerPrxHelper()
                                            h.copyFrom__(bb)
                                            Return h
                                        End If
                                    Catch ex__ As Ice.FacetNotExistException
                                    End Try
                                    Return Nothing
                                End Function

                                Public Shared Function uncheckedCast(ByVal b As Ice.ObjectPrx) As EventListenerPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim h As EventListenerPrxHelper = new EventListenerPrxHelper()
                                    h.copyFrom__(b)
                                    Return h
                                End Function

                                Public Shared Function uncheckedCast(Byval b As Ice.ObjectPrx, ByVal f As string) As EventListenerPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Dim h As EventListenerPrxHelper = new EventListenerPrxHelper()
                                    h.copyFrom__(bb)
                                    Return h
                                End Function

#End Region

#Region "Marshaling support"

                                Protected Overrides Function createDelegateM__() As Ice.ObjectDelM_
                                    Return New _EventListenerDelM()
                                End Function

                                Protected Overrides Function createDelegateD__() As Ice.ObjectDelD_
                                    Return New _EventListenerDelD()
                                End Function

                                Public Shared Sub write__(ByVal os__ As IceInternal.BasicStream, ByVal v__ As EventListenerPrx)
                                    os__.writeProxy(v__)
                                End Sub

                                Public Shared Function read__(ByVal is__ As IceInternal.BasicStream) As EventListenerPrx
                                    Dim proxy As Ice.ObjectPrx = is__.readProxy()
                                    If Not proxy Is Nothing Then
                                        Dim result As EventListenerPrxHelper = New EventListenerPrxHelper
                                        result.copyFrom__(proxy)
                                        Return result
                                    End If
                                    Return Nothing
                                End Function

#End Region

                            End Class

                            Public NotInheritable Class MailboxPrxHelper
                                Inherits Ice.ObjectPrxHelperBase
                                Implements MailboxPrx

#Region "Synchronous operations"

                                Public Function active() As Boolean Implements MailboxPrx.active
                                    Return active(Nothing, False)
                                End Function

                                Public Function active(ByVal context__ As Ice.Context) As Boolean Implements MailboxPrx.active
                                    Return active(context__, True)
                                End Function

                                Private Function active(ByVal context__ As Ice.Context, explicitContext__ As Boolean) As Boolean
                                    If explicitContext__ And context__ Is Nothing Then
                                        context__ = emptyContext_
                                    End If
                                    Dim cnt__ As Integer = 0
                                    While True
                                        Dim delBase__ As Ice.ObjectDel_ = Nothing
                                        Try
                                            checkTwowayOnly__("active")
                                            delBase__ = getDelegate__()
                                            Dim del__ As _MailboxDel = CType(delBase__, _MailboxDel)
                                            Return del__.active(context__)
                                        Catch ex__ As IceInternal.LocalExceptionWrapper
                                            handleExceptionWrapper__(delBase__, ex__)
                                        Catch ex__ As Ice.LocalException
                                            cnt__ = handleException__(delBase__, ex__, cnt__)
                                        End Try
                                    End While
                                    Return Nothing
                                End Function

                                Public Sub addListener(ByVal listener As matt.messaging.EventListenerPrx) Implements MailboxPrx.addListener
                                    addListener(listener, Nothing, False)
                                End Sub

                                Public Sub addListener(ByVal listener As matt.messaging.EventListenerPrx, ByVal context__ As Ice.Context) Implements MailboxPrx.addListener
                                    addListener(listener, context__, True)
                                End Sub

                                Private Sub addListener(ByVal listener As matt.messaging.EventListenerPrx, ByVal context__ As Ice.Context, explicitContext__ As Boolean)
                                    If explicitContext__ And context__ Is Nothing Then
                                        context__ = emptyContext_
                                    End If
                                    Dim cnt__ As Integer = 0
                                    While True
                                        Dim delBase__ As Ice.ObjectDel_ = Nothing
                                        Try
                                            checkTwowayOnly__("addListener")
                                            delBase__ = getDelegate__()
                                            Dim del__ As _MailboxDel = CType(delBase__, _MailboxDel)
                                            del__.addListener(listener, context__)
                                            Return
                                        Catch ex__ As IceInternal.LocalExceptionWrapper
                                            handleExceptionWrapper__(delBase__, ex__)
                                        Catch ex__ As Ice.LocalException
                                            cnt__ = handleException__(delBase__, ex__, cnt__)
                                        End Try
                                    End While
                                End Sub

                                Public Function empty() As Boolean Implements MailboxPrx.empty
                                    Return empty(Nothing, False)
                                End Function

                                Public Function empty(ByVal context__ As Ice.Context) As Boolean Implements MailboxPrx.empty
                                    Return empty(context__, True)
                                End Function

                                Private Function empty(ByVal context__ As Ice.Context, explicitContext__ As Boolean) As Boolean
                                    If explicitContext__ And context__ Is Nothing Then
                                        context__ = emptyContext_
                                    End If
                                    Dim cnt__ As Integer = 0
                                    While True
                                        Dim delBase__ As Ice.ObjectDel_ = Nothing
                                        Try
                                            checkTwowayOnly__("empty")
                                            delBase__ = getDelegate__()
                                            Dim del__ As _MailboxDel = CType(delBase__, _MailboxDel)
                                            Return del__.empty(context__)
                                        Catch ex__ As IceInternal.LocalExceptionWrapper
                                            handleExceptionWrapper__(delBase__, ex__)
                                        Catch ex__ As Ice.LocalException
                                            cnt__ = handleException__(delBase__, ex__, cnt__)
                                        End Try
                                    End While
                                    Return Nothing
                                End Function

                                Public Function read() As String Implements MailboxPrx.read
                                    Return read(Nothing, False)
                                End Function

                                Public Function read(ByVal context__ As Ice.Context) As String Implements MailboxPrx.read
                                    Return read(context__, True)
                                End Function

                                Private Function read(ByVal context__ As Ice.Context, explicitContext__ As Boolean) As String
                                    If explicitContext__ And context__ Is Nothing Then
                                        context__ = emptyContext_
                                    End If
                                    Dim cnt__ As Integer = 0
                                    While True
                                        Dim delBase__ As Ice.ObjectDel_ = Nothing
                                        Try
                                            checkTwowayOnly__("read")
                                            delBase__ = getDelegate__()
                                            Dim del__ As _MailboxDel = CType(delBase__, _MailboxDel)
                                            Return del__.read(context__)
                                        Catch ex__ As IceInternal.LocalExceptionWrapper
                                            handleExceptionWrapper__(delBase__, ex__)
                                        Catch ex__ As Ice.LocalException
                                            cnt__ = handleException__(delBase__, ex__, cnt__)
                                        End Try
                                    End While
                                    Return Nothing
                                End Function

                                Public Sub removeListener() Implements MailboxPrx.removeListener
                                    removeListener(Nothing, False)
                                End Sub

                                Public Sub removeListener(ByVal context__ As Ice.Context) Implements MailboxPrx.removeListener
                                    removeListener(context__, True)
                                End Sub

                                Private Sub removeListener(ByVal context__ As Ice.Context, explicitContext__ As Boolean)
                                    If explicitContext__ And context__ Is Nothing Then
                                        context__ = emptyContext_
                                    End If
                                    Dim cnt__ As Integer = 0
                                    While True
                                        Dim delBase__ As Ice.ObjectDel_ = Nothing
                                        Try
                                            checkTwowayOnly__("removeListener")
                                            delBase__ = getDelegate__()
                                            Dim del__ As _MailboxDel = CType(delBase__, _MailboxDel)
                                            del__.removeListener(context__)
                                            Return
                                        Catch ex__ As IceInternal.LocalExceptionWrapper
                                            handleExceptionWrapper__(delBase__, ex__)
                                        Catch ex__ As Ice.LocalException
                                            cnt__ = handleException__(delBase__, ex__, cnt__)
                                        End Try
                                    End While
                                End Sub

                                Public Sub write(ByVal message As String) Implements MailboxPrx.write
                                    write(message, Nothing, False)
                                End Sub

                                Public Sub write(ByVal message As String, ByVal context__ As Ice.Context) Implements MailboxPrx.write
                                    write(message, context__, True)
                                End Sub

                                Private Sub write(ByVal message As String, ByVal context__ As Ice.Context, explicitContext__ As Boolean)
                                    If explicitContext__ And context__ Is Nothing Then
                                        context__ = emptyContext_
                                    End If
                                    Dim cnt__ As Integer = 0
                                    While True
                                        Dim delBase__ As Ice.ObjectDel_ = Nothing
                                        Try
                                            checkTwowayOnly__("write")
                                            delBase__ = getDelegate__()
                                            Dim del__ As _MailboxDel = CType(delBase__, _MailboxDel)
                                            del__.write(message, context__)
                                            Return
                                        Catch ex__ As IceInternal.LocalExceptionWrapper
                                            handleExceptionWrapper__(delBase__, ex__)
                                        Catch ex__ As Ice.LocalException
                                            cnt__ = handleException__(delBase__, ex__, cnt__)
                                        End Try
                                    End While
                                End Sub

#End Region

#Region "Checked and unchecked cast operations"

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx) As MailboxPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    If TypeOf b Is MailboxPrx Then
                                        Return CType(b, MailboxPrx)
                                    End If
                                    If b.ice_isA("::matt::messaging::Mailbox") Then
                                        Dim h As MailboxPrxHelper = New MailboxPrxHelper
                                        h.copyFrom__(b)
                                        Return h
                                    End If
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal ctx As Ice.Context) As MailboxPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    If TypeOf b Is MailboxPrx Then
                                        Return CType(b, MailboxPrx)
                                    End If
                                    If b.ice_isA("::matt::messaging::Mailbox", ctx) Then
                                        Dim h As MailboxPrxHelper = New MailboxPrxHelper
                                        h.copyFrom__(b)
                                        Return h
                                    End If
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal f As String) As MailboxPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Try
                                        If bb.ice_isA("::matt::messaging::Mailbox") Then
                                            Dim h As MailboxPrxHelper = new MailboxPrxHelper()
                                            h.copyFrom__(bb)
                                            Return h
                                        End If
                                    Catch ex__ As Ice.FacetNotExistException
                                    End Try
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal f As String, ByVal ctx As Ice.Context) As MailboxPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Try
                                        If bb.ice_isA("::matt::messaging::Mailbox", ctx) Then
                                            Dim h As MailboxPrxHelper = new MailboxPrxHelper()
                                            h.copyFrom__(bb)
                                            Return h
                                        End If
                                    Catch ex__ As Ice.FacetNotExistException
                                    End Try
                                    Return Nothing
                                End Function

                                Public Shared Function uncheckedCast(ByVal b As Ice.ObjectPrx) As MailboxPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim h As MailboxPrxHelper = new MailboxPrxHelper()
                                    h.copyFrom__(b)
                                    Return h
                                End Function

                                Public Shared Function uncheckedCast(Byval b As Ice.ObjectPrx, ByVal f As string) As MailboxPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Dim h As MailboxPrxHelper = new MailboxPrxHelper()
                                    h.copyFrom__(bb)
                                    Return h
                                End Function

#End Region

#Region "Marshaling support"

                                Protected Overrides Function createDelegateM__() As Ice.ObjectDelM_
                                    Return New _MailboxDelM()
                                End Function

                                Protected Overrides Function createDelegateD__() As Ice.ObjectDelD_
                                    Return New _MailboxDelD()
                                End Function

                                Public Shared Sub write__(ByVal os__ As IceInternal.BasicStream, ByVal v__ As MailboxPrx)
                                    os__.writeProxy(v__)
                                End Sub

                                Public Shared Function read__(ByVal is__ As IceInternal.BasicStream) As MailboxPrx
                                    Dim proxy As Ice.ObjectPrx = is__.readProxy()
                                    If Not proxy Is Nothing Then
                                        Dim result As MailboxPrxHelper = New MailboxPrxHelper
                                        result.copyFrom__(proxy)
                                        Return result
                                    End If
                                    Return Nothing
                                End Function

#End Region

                            End Class

                        End Namespace

                        Namespace roles

                            Public NotInheritable Class ParticipantPrxHelper
                                Inherits Ice.ObjectPrxHelperBase
                                Implements ParticipantPrx

#Region "Synchronous operations"

                                Public Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx) Implements ParticipantPrx.setMailbox
                                    setMailbox(mb, Nothing, False)
                                End Sub

                                Public Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx, ByVal context__ As Ice.Context) Implements ParticipantPrx.setMailbox
                                    setMailbox(mb, context__, True)
                                End Sub

                                Private Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx, ByVal context__ As Ice.Context, explicitContext__ As Boolean)
                                    If explicitContext__ And context__ Is Nothing Then
                                        context__ = emptyContext_
                                    End If
                                    Dim cnt__ As Integer = 0
                                    While True
                                        Dim delBase__ As Ice.ObjectDel_ = Nothing
                                        Try
                                            delBase__ = getDelegate__()
                                            Dim del__ As _ParticipantDel = CType(delBase__, _ParticipantDel)
                                            del__.setMailbox(mb, context__)
                                            Return
                                        Catch ex__ As IceInternal.LocalExceptionWrapper
                                            handleExceptionWrapper__(delBase__, ex__)
                                        Catch ex__ As Ice.LocalException
                                            cnt__ = handleException__(delBase__, ex__, cnt__)
                                        End Try
                                    End While
                                End Sub

#End Region

#Region "Checked and unchecked cast operations"

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx) As ParticipantPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    If TypeOf b Is ParticipantPrx Then
                                        Return CType(b, ParticipantPrx)
                                    End If
                                    If b.ice_isA("::matt::roles::Participant") Then
                                        Dim h As ParticipantPrxHelper = New ParticipantPrxHelper
                                        h.copyFrom__(b)
                                        Return h
                                    End If
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal ctx As Ice.Context) As ParticipantPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    If TypeOf b Is ParticipantPrx Then
                                        Return CType(b, ParticipantPrx)
                                    End If
                                    If b.ice_isA("::matt::roles::Participant", ctx) Then
                                        Dim h As ParticipantPrxHelper = New ParticipantPrxHelper
                                        h.copyFrom__(b)
                                        Return h
                                    End If
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal f As String) As ParticipantPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Try
                                        If bb.ice_isA("::matt::roles::Participant") Then
                                            Dim h As ParticipantPrxHelper = new ParticipantPrxHelper()
                                            h.copyFrom__(bb)
                                            Return h
                                        End If
                                    Catch ex__ As Ice.FacetNotExistException
                                    End Try
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal f As String, ByVal ctx As Ice.Context) As ParticipantPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Try
                                        If bb.ice_isA("::matt::roles::Participant", ctx) Then
                                            Dim h As ParticipantPrxHelper = new ParticipantPrxHelper()
                                            h.copyFrom__(bb)
                                            Return h
                                        End If
                                    Catch ex__ As Ice.FacetNotExistException
                                    End Try
                                    Return Nothing
                                End Function

                                Public Shared Function uncheckedCast(ByVal b As Ice.ObjectPrx) As ParticipantPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim h As ParticipantPrxHelper = new ParticipantPrxHelper()
                                    h.copyFrom__(b)
                                    Return h
                                End Function

                                Public Shared Function uncheckedCast(Byval b As Ice.ObjectPrx, ByVal f As string) As ParticipantPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Dim h As ParticipantPrxHelper = new ParticipantPrxHelper()
                                    h.copyFrom__(bb)
                                    Return h
                                End Function

#End Region

#Region "Marshaling support"

                                Protected Overrides Function createDelegateM__() As Ice.ObjectDelM_
                                    Return New _ParticipantDelM()
                                End Function

                                Protected Overrides Function createDelegateD__() As Ice.ObjectDelD_
                                    Return New _ParticipantDelD()
                                End Function

                                Public Shared Sub write__(ByVal os__ As IceInternal.BasicStream, ByVal v__ As ParticipantPrx)
                                    os__.writeProxy(v__)
                                End Sub

                                Public Shared Function read__(ByVal is__ As IceInternal.BasicStream) As ParticipantPrx
                                    Dim proxy As Ice.ObjectPrx = is__.readProxy()
                                    If Not proxy Is Nothing Then
                                        Dim result As ParticipantPrxHelper = New ParticipantPrxHelper
                                        result.copyFrom__(proxy)
                                        Return result
                                    End If
                                    Return Nothing
                                End Function

#End Region

                            End Class

                            Public NotInheritable Class MediatorPrxHelper
                                Inherits Ice.ObjectPrxHelperBase
                                Implements MediatorPrx

#Region "Synchronous operations"

                                Public Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx) Implements MediatorPrx.registerParticipant
                                    registerParticipant(p, Nothing, False)
                                End Sub

                                Public Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx, ByVal context__ As Ice.Context) Implements MediatorPrx.registerParticipant
                                    registerParticipant(p, context__, True)
                                End Sub

                                Private Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx, ByVal context__ As Ice.Context, explicitContext__ As Boolean)
                                    If explicitContext__ And context__ Is Nothing Then
                                        context__ = emptyContext_
                                    End If
                                    Dim cnt__ As Integer = 0
                                    While True
                                        Dim delBase__ As Ice.ObjectDel_ = Nothing
                                        Try
                                            delBase__ = getDelegate__()
                                            Dim del__ As _MediatorDel = CType(delBase__, _MediatorDel)
                                            del__.registerParticipant(p, context__)
                                            Return
                                        Catch ex__ As IceInternal.LocalExceptionWrapper
                                            handleExceptionWrapper__(delBase__, ex__)
                                        Catch ex__ As Ice.LocalException
                                            cnt__ = handleException__(delBase__, ex__, cnt__)
                                        End Try
                                    End While
                                End Sub

#End Region

#Region "Checked and unchecked cast operations"

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx) As MediatorPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    If TypeOf b Is MediatorPrx Then
                                        Return CType(b, MediatorPrx)
                                    End If
                                    If b.ice_isA("::matt::roles::Mediator") Then
                                        Dim h As MediatorPrxHelper = New MediatorPrxHelper
                                        h.copyFrom__(b)
                                        Return h
                                    End If
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal ctx As Ice.Context) As MediatorPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    If TypeOf b Is MediatorPrx Then
                                        Return CType(b, MediatorPrx)
                                    End If
                                    If b.ice_isA("::matt::roles::Mediator", ctx) Then
                                        Dim h As MediatorPrxHelper = New MediatorPrxHelper
                                        h.copyFrom__(b)
                                        Return h
                                    End If
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal f As String) As MediatorPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Try
                                        If bb.ice_isA("::matt::roles::Mediator") Then
                                            Dim h As MediatorPrxHelper = new MediatorPrxHelper()
                                            h.copyFrom__(bb)
                                            Return h
                                        End If
                                    Catch ex__ As Ice.FacetNotExistException
                                    End Try
                                    Return Nothing
                                End Function

                                Public Shared Function checkedCast(ByVal b As Ice.ObjectPrx, ByVal f As String, ByVal ctx As Ice.Context) As MediatorPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Try
                                        If bb.ice_isA("::matt::roles::Mediator", ctx) Then
                                            Dim h As MediatorPrxHelper = new MediatorPrxHelper()
                                            h.copyFrom__(bb)
                                            Return h
                                        End If
                                    Catch ex__ As Ice.FacetNotExistException
                                    End Try
                                    Return Nothing
                                End Function

                                Public Shared Function uncheckedCast(ByVal b As Ice.ObjectPrx) As MediatorPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim h As MediatorPrxHelper = new MediatorPrxHelper()
                                    h.copyFrom__(b)
                                    Return h
                                End Function

                                Public Shared Function uncheckedCast(Byval b As Ice.ObjectPrx, ByVal f As string) As MediatorPrx
                                    If b Is Nothing Then
                                        Return Nothing
                                    End If
                                    Dim bb As Ice.ObjectPrx = b.ice_facet(f)
                                    Dim h As MediatorPrxHelper = new MediatorPrxHelper()
                                    h.copyFrom__(bb)
                                    Return h
                                End Function

#End Region

#Region "Marshaling support"

                                Protected Overrides Function createDelegateM__() As Ice.ObjectDelM_
                                    Return New _MediatorDelM()
                                End Function

                                Protected Overrides Function createDelegateD__() As Ice.ObjectDelD_
                                    Return New _MediatorDelD()
                                End Function

                                Public Shared Sub write__(ByVal os__ As IceInternal.BasicStream, ByVal v__ As MediatorPrx)
                                    os__.writeProxy(v__)
                                End Sub

                                Public Shared Function read__(ByVal is__ As IceInternal.BasicStream) As MediatorPrx
                                    Dim proxy As Ice.ObjectPrx = is__.readProxy()
                                    If Not proxy Is Nothing Then
                                        Dim result As MediatorPrxHelper = New MediatorPrxHelper
                                        result.copyFrom__(proxy)
                                        Return result
                                    End If
                                    Return Nothing
                                End Function

#End Region

                            End Class

                        End Namespace

                    End Namespace

                    Namespace matt

                        Namespace messaging

                            Public Interface _EventListenerDel
                                Inherits Ice.ObjectDel_

                                Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String, ByVal context__ As Ice.Context)

                            End Interface

                            Public Interface _MailboxDel
                                Inherits Ice.ObjectDel_

                                Function empty(ByVal context__ As Ice.Context) As Boolean

                                Function active(ByVal context__ As Ice.Context) As Boolean

                                Function read(ByVal context__ As Ice.Context) As String

                                Sub write(ByVal message As String, ByVal context__ As Ice.Context)

                                Sub addListener(ByVal listener As matt.messaging.EventListenerPrx, ByVal context__ As Ice.Context)

                                Sub removeListener(ByVal context__ As Ice.Context)

                            End Interface

                        End Namespace

                        Namespace roles

                            Public Interface _ParticipantDel
                                Inherits Ice.ObjectDel_

                                Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx, ByVal context__ As Ice.Context)

                            End Interface

                            Public Interface _MediatorDel
                                Inherits Ice.ObjectDel_

                                Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx, ByVal context__ As Ice.Context)

                            End Interface

                        End Namespace

                    End Namespace

                    Namespace matt

                        Namespace messaging

                            Public NotInheritable class _EventListenerDelM
                                Inherits Ice.ObjectDelM_
                                Implements _EventListenerDel

                                Public Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String, ByVal context__ As Ice.Context) Implements _EventListenerDel.onEvent
                                    Dim og__ As IceInternal.Outgoing = getOutgoing("onEvent", Ice.OperationMode.Normal, context__)
                                    Try
                                        Try
                                            Dim os__ As IceInternal.BasicStream = og__.ostr()
                                            os__.writeByte(CType([event], Byte))
                                            os__.writeString(message)
                                        Catch ex__ As Ice.LocalException
                                            og__.abort(ex__)
                                        End Try
                                        Dim ok__ As Boolean = og__.invoke()
                                        Try
                                            Dim is__ As IceInternal.BasicStream = og__.istr()
                                            If Not ok__ Then
                                                Try
                                                    is__.throwException()
                                                Catch ex__ As Ice.UserException
                                                    Throw New Ice.UnknownUserException(ex__)
                                                End Try
                                            End If
                                        Catch ex__ As Ice.LocalException
                                            throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                        End Try
                                    Finally
                                        reclaimOutgoing(og__)
                                    End Try
                                End Sub

                            End Class

                            Public NotInheritable class _MailboxDelM
                                Inherits Ice.ObjectDelM_
                                Implements _MailboxDel

                                Public Function active(ByVal context__ As Ice.Context) As Boolean Implements _MailboxDel.active
                                    Dim og__ As IceInternal.Outgoing = getOutgoing("active", Ice.OperationMode.Normal, context__)
                                    Try
                                        Dim ok__ As Boolean = og__.invoke()
                                        Try
                                            Dim is__ As IceInternal.BasicStream = og__.istr()
                                            If Not ok__ Then
                                                Try
                                                    is__.throwException()
                                                Catch ex__ As Ice.UserException
                                                    Throw New Ice.UnknownUserException(ex__)
                                                End Try
                                            End If
                                            Dim ret__ As Boolean = Nothing
                                            ret__ = is__.readBool()
                                            Return ret__
                                        Catch ex__ As Ice.LocalException
                                            throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                        End Try
                                    Finally
                                        reclaimOutgoing(og__)
                                    End Try
                                End Function

                                Public Sub addListener(ByVal listener As matt.messaging.EventListenerPrx, ByVal context__ As Ice.Context) Implements _MailboxDel.addListener
                                    Dim og__ As IceInternal.Outgoing = getOutgoing("addListener", Ice.OperationMode.Normal, context__)
                                    Try
                                        Try
                                            Dim os__ As IceInternal.BasicStream = og__.ostr()
                                            matt.messaging.EventListenerPrxHelper.write__(os__, listener)
                                        Catch ex__ As Ice.LocalException
                                            og__.abort(ex__)
                                        End Try
                                        Dim ok__ As Boolean = og__.invoke()
                                        Try
                                            Dim is__ As IceInternal.BasicStream = og__.istr()
                                            If Not ok__ Then
                                                Try
                                                    is__.throwException()
                                                Catch ex__ As matt.MattAlreadyListeningException
                                                    Throw
                                                Catch ex__ As matt.MattListenException
                                                    Throw
                                                Catch ex__ As matt.MattNotActiveException
                                                    Throw
                                                Catch ex__ As Ice.UserException
                                                    Throw New Ice.UnknownUserException(ex__)
                                                End Try
                                            End If
                                        Catch ex__ As Ice.LocalException
                                            throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                        End Try
                                    Finally
                                        reclaimOutgoing(og__)
                                    End Try
                                End Sub

                                Public Function empty(ByVal context__ As Ice.Context) As Boolean Implements _MailboxDel.empty
                                    Dim og__ As IceInternal.Outgoing = getOutgoing("empty", Ice.OperationMode.Normal, context__)
                                    Try
                                        Dim ok__ As Boolean = og__.invoke()
                                        Try
                                            Dim is__ As IceInternal.BasicStream = og__.istr()
                                            If Not ok__ Then
                                                Try
                                                    is__.throwException()
                                                Catch ex__ As Ice.UserException
                                                    Throw New Ice.UnknownUserException(ex__)
                                                End Try
                                            End If
                                            Dim ret__ As Boolean = Nothing
                                            ret__ = is__.readBool()
                                            Return ret__
                                        Catch ex__ As Ice.LocalException
                                            throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                        End Try
                                    Finally
                                        reclaimOutgoing(og__)
                                    End Try
                                End Function

                                Public Function read(ByVal context__ As Ice.Context) As String Implements _MailboxDel.read
                                    Dim og__ As IceInternal.Outgoing = getOutgoing("read", Ice.OperationMode.Normal, context__)
                                    Try
                                        Dim ok__ As Boolean = og__.invoke()
                                        Try
                                            Dim is__ As IceInternal.BasicStream = og__.istr()
                                            If Not ok__ Then
                                                Try
                                                    is__.throwException()
                                                Catch ex__ As matt.MattNoMessageException
                                                    Throw
                                                Catch ex__ As matt.MattNotActiveException
                                                    Throw
                                                Catch ex__ As Ice.UserException
                                                    Throw New Ice.UnknownUserException(ex__)
                                                End Try
                                            End If
                                            Dim ret__ As String = Nothing
                                            ret__ = is__.readString()
                                            Return ret__
                                        Catch ex__ As Ice.LocalException
                                            throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                        End Try
                                    Finally
                                        reclaimOutgoing(og__)
                                    End Try
                                End Function

                                Public Sub removeListener(ByVal context__ As Ice.Context) Implements _MailboxDel.removeListener
                                    Dim og__ As IceInternal.Outgoing = getOutgoing("removeListener", Ice.OperationMode.Normal, context__)
                                    Try
                                        Dim ok__ As Boolean = og__.invoke()
                                        Try
                                            Dim is__ As IceInternal.BasicStream = og__.istr()
                                            If Not ok__ Then
                                                Try
                                                    is__.throwException()
                                                Catch ex__ As matt.MattNotListeningException
                                                    Throw
                                                Catch ex__ As matt.MattListenException
                                                    Throw
                                                Catch ex__ As matt.MattNotActiveException
                                                    Throw
                                                Catch ex__ As Ice.UserException
                                                    Throw New Ice.UnknownUserException(ex__)
                                                End Try
                                            End If
                                        Catch ex__ As Ice.LocalException
                                            throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                        End Try
                                    Finally
                                        reclaimOutgoing(og__)
                                    End Try
                                End Sub

                                Public Sub write(ByVal message As String, ByVal context__ As Ice.Context) Implements _MailboxDel.write
                                    Dim og__ As IceInternal.Outgoing = getOutgoing("write", Ice.OperationMode.Normal, context__)
                                    Try
                                        Try
                                            Dim os__ As IceInternal.BasicStream = og__.ostr()
                                            os__.writeString(message)
                                        Catch ex__ As Ice.LocalException
                                            og__.abort(ex__)
                                        End Try
                                        Dim ok__ As Boolean = og__.invoke()
                                        Try
                                            Dim is__ As IceInternal.BasicStream = og__.istr()
                                            If Not ok__ Then
                                                Try
                                                    is__.throwException()
                                                Catch ex__ As matt.MattNotActiveException
                                                    Throw
                                                Catch ex__ As Ice.UserException
                                                    Throw New Ice.UnknownUserException(ex__)
                                                End Try
                                            End If
                                        Catch ex__ As Ice.LocalException
                                            throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                        End Try
                                    Finally
                                        reclaimOutgoing(og__)
                                    End Try
                                End Sub

                            End Class

                        End Namespace

                        Namespace roles

                            Public NotInheritable class _ParticipantDelM
                                Inherits Ice.ObjectDelM_
                                Implements _ParticipantDel

                                Public Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx, ByVal context__ As Ice.Context) Implements _ParticipantDel.setMailbox
                                    Dim og__ As IceInternal.Outgoing = getOutgoing("setMailbox", Ice.OperationMode.Normal, context__)
                                    Try
                                        Try
                                            Dim os__ As IceInternal.BasicStream = og__.ostr()
                                            matt.messaging.MailboxPrxHelper.write__(os__, mb)
                                        Catch ex__ As Ice.LocalException
                                            og__.abort(ex__)
                                        End Try
                                        Dim ok__ As Boolean = og__.invoke()
                                        Try
                                            Dim is__ As IceInternal.BasicStream = og__.istr()
                                            If Not ok__ Then
                                                Try
                                                    is__.throwException()
                                                Catch ex__ As Ice.UserException
                                                    Throw New Ice.UnknownUserException(ex__)
                                                End Try
                                            End If
                                        Catch ex__ As Ice.LocalException
                                            throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                        End Try
                                    Finally
                                        reclaimOutgoing(og__)
                                    End Try
                                End Sub

                            End Class

                            Public NotInheritable class _MediatorDelM
                                Inherits Ice.ObjectDelM_
                                Implements _MediatorDel

                                Public Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx, ByVal context__ As Ice.Context) Implements _MediatorDel.registerParticipant
                                    Dim og__ As IceInternal.Outgoing = getOutgoing("registerParticipant", Ice.OperationMode.Normal, context__)
                                    Try
                                        Try
                                            Dim os__ As IceInternal.BasicStream = og__.ostr()
                                            matt.roles.ParticipantPrxHelper.write__(os__, p)
                                        Catch ex__ As Ice.LocalException
                                            og__.abort(ex__)
                                        End Try
                                        Dim ok__ As Boolean = og__.invoke()
                                        Try
                                            Dim is__ As IceInternal.BasicStream = og__.istr()
                                            If Not ok__ Then
                                                Try
                                                    is__.throwException()
                                                Catch ex__ As Ice.UserException
                                                    Throw New Ice.UnknownUserException(ex__)
                                                End Try
                                            End If
                                        Catch ex__ As Ice.LocalException
                                            throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                        End Try
                                    Finally
                                        reclaimOutgoing(og__)
                                    End Try
                                End Sub

                            End Class

                        End Namespace

                    End Namespace

                    Namespace matt

                        Namespace messaging

                            Public NotInheritable class _EventListenerDelD
                                Inherits Ice.ObjectDelD_
                                Implements _EventListenerDel

                                Public Sub onEvent(ByVal [event] As matt.messaging.EventType, ByVal message As String, ByVal context__ As Ice.Context) Implements _EventListenerDel.onEvent
                                    Dim current__ As Ice.Current = New Ice.Current
                                    initCurrent__(current__, "onEvent", Ice.OperationMode.Normal, context__)
                                    While True
                                        Dim direct__ As IceInternal.Direct = New IceInternal.Direct(current__)
                                        Dim servant__ As Object = direct__.servant()
                                        If TypeOf servant__ Is EventListener Then
                                            Try
                                                CType(servant__, matt.messaging.EventListenerOperations_).onEvent([event], message, current__)
                                                Return
                                            Catch ex__ As Ice.LocalException
                                                Throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                            Finally
                                                direct__.destroy()
                                            End Try
                                        Else
                                            direct__.destroy()
                                            Dim opEx__ As Ice.OperationNotExistException = new Ice.OperationNotExistException()
                                            opEx__.id = current__.id
                                            opEx__.facet = current__.facet
                                            opEx__.operation = current__.operation
                                            Throw opEx__
                                        End If
                                    End While
                                End Sub

                            End Class

                            Public NotInheritable class _MailboxDelD
                                Inherits Ice.ObjectDelD_
                                Implements _MailboxDel

                                Public Function active(ByVal context__ As Ice.Context) As Boolean Implements _MailboxDel.active
                                    Dim current__ As Ice.Current = New Ice.Current
                                    initCurrent__(current__, "active", Ice.OperationMode.Normal, context__)
                                    While True
                                        Dim direct__ As IceInternal.Direct = New IceInternal.Direct(current__)
                                        Dim servant__ As Object = direct__.servant()
                                        If TypeOf servant__ Is Mailbox Then
                                            Try
                                                Return CType(servant__, matt.messaging.MailboxOperations_).active(current__)
                                            Catch ex__ As Ice.LocalException
                                                Throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                            Finally
                                                direct__.destroy()
                                            End Try
                                        Else
                                            direct__.destroy()
                                            Dim opEx__ As Ice.OperationNotExistException = new Ice.OperationNotExistException()
                                            opEx__.id = current__.id
                                            opEx__.facet = current__.facet
                                            opEx__.operation = current__.operation
                                            Throw opEx__
                                        End If
                                    End While
                                    Return Nothing
                                End Function

                                Public Sub addListener(ByVal listener As matt.messaging.EventListenerPrx, ByVal context__ As Ice.Context) Implements _MailboxDel.addListener
                                    Dim current__ As Ice.Current = New Ice.Current
                                    initCurrent__(current__, "addListener", Ice.OperationMode.Normal, context__)
                                    While True
                                        Dim direct__ As IceInternal.Direct = New IceInternal.Direct(current__)
                                        Dim servant__ As Object = direct__.servant()
                                        If TypeOf servant__ Is Mailbox Then
                                            Try
                                                CType(servant__, matt.messaging.MailboxOperations_).addListener(listener, current__)
                                                Return
                                            Catch ex__ As Ice.LocalException
                                                Throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                            Finally
                                                direct__.destroy()
                                            End Try
                                        Else
                                            direct__.destroy()
                                            Dim opEx__ As Ice.OperationNotExistException = new Ice.OperationNotExistException()
                                            opEx__.id = current__.id
                                            opEx__.facet = current__.facet
                                            opEx__.operation = current__.operation
                                            Throw opEx__
                                        End If
                                    End While
                                End Sub

                                Public Function empty(ByVal context__ As Ice.Context) As Boolean Implements _MailboxDel.empty
                                    Dim current__ As Ice.Current = New Ice.Current
                                    initCurrent__(current__, "empty", Ice.OperationMode.Normal, context__)
                                    While True
                                        Dim direct__ As IceInternal.Direct = New IceInternal.Direct(current__)
                                        Dim servant__ As Object = direct__.servant()
                                        If TypeOf servant__ Is Mailbox Then
                                            Try
                                                Return CType(servant__, matt.messaging.MailboxOperations_).empty(current__)
                                            Catch ex__ As Ice.LocalException
                                                Throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                            Finally
                                                direct__.destroy()
                                            End Try
                                        Else
                                            direct__.destroy()
                                            Dim opEx__ As Ice.OperationNotExistException = new Ice.OperationNotExistException()
                                            opEx__.id = current__.id
                                            opEx__.facet = current__.facet
                                            opEx__.operation = current__.operation
                                            Throw opEx__
                                        End If
                                    End While
                                    Return Nothing
                                End Function

                                Public Function read(ByVal context__ As Ice.Context) As String Implements _MailboxDel.read
                                    Dim current__ As Ice.Current = New Ice.Current
                                    initCurrent__(current__, "read", Ice.OperationMode.Normal, context__)
                                    While True
                                        Dim direct__ As IceInternal.Direct = New IceInternal.Direct(current__)
                                        Dim servant__ As Object = direct__.servant()
                                        If TypeOf servant__ Is Mailbox Then
                                            Try
                                                Return CType(servant__, matt.messaging.MailboxOperations_).read(current__)
                                            Catch ex__ As Ice.LocalException
                                                Throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                            Finally
                                                direct__.destroy()
                                            End Try
                                        Else
                                            direct__.destroy()
                                            Dim opEx__ As Ice.OperationNotExistException = new Ice.OperationNotExistException()
                                            opEx__.id = current__.id
                                            opEx__.facet = current__.facet
                                            opEx__.operation = current__.operation
                                            Throw opEx__
                                        End If
                                    End While
                                    Return Nothing
                                End Function

                                Public Sub removeListener(ByVal context__ As Ice.Context) Implements _MailboxDel.removeListener
                                    Dim current__ As Ice.Current = New Ice.Current
                                    initCurrent__(current__, "removeListener", Ice.OperationMode.Normal, context__)
                                    While True
                                        Dim direct__ As IceInternal.Direct = New IceInternal.Direct(current__)
                                        Dim servant__ As Object = direct__.servant()
                                        If TypeOf servant__ Is Mailbox Then
                                            Try
                                                CType(servant__, matt.messaging.MailboxOperations_).removeListener(current__)
                                                Return
                                            Catch ex__ As Ice.LocalException
                                                Throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                            Finally
                                                direct__.destroy()
                                            End Try
                                        Else
                                            direct__.destroy()
                                            Dim opEx__ As Ice.OperationNotExistException = new Ice.OperationNotExistException()
                                            opEx__.id = current__.id
                                            opEx__.facet = current__.facet
                                            opEx__.operation = current__.operation
                                            Throw opEx__
                                        End If
                                    End While
                                End Sub

                                Public Sub write(ByVal message As String, ByVal context__ As Ice.Context) Implements _MailboxDel.write
                                    Dim current__ As Ice.Current = New Ice.Current
                                    initCurrent__(current__, "write", Ice.OperationMode.Normal, context__)
                                    While True
                                        Dim direct__ As IceInternal.Direct = New IceInternal.Direct(current__)
                                        Dim servant__ As Object = direct__.servant()
                                        If TypeOf servant__ Is Mailbox Then
                                            Try
                                                CType(servant__, matt.messaging.MailboxOperations_).write(message, current__)
                                                Return
                                            Catch ex__ As Ice.LocalException
                                                Throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                            Finally
                                                direct__.destroy()
                                            End Try
                                        Else
                                            direct__.destroy()
                                            Dim opEx__ As Ice.OperationNotExistException = new Ice.OperationNotExistException()
                                            opEx__.id = current__.id
                                            opEx__.facet = current__.facet
                                            opEx__.operation = current__.operation
                                            Throw opEx__
                                        End If
                                    End While
                                End Sub

                            End Class

                        End Namespace

                        Namespace roles

                            Public NotInheritable class _ParticipantDelD
                                Inherits Ice.ObjectDelD_
                                Implements _ParticipantDel

                                Public Sub setMailbox(ByVal mb As matt.messaging.MailboxPrx, ByVal context__ As Ice.Context) Implements _ParticipantDel.setMailbox
                                    Dim current__ As Ice.Current = New Ice.Current
                                    initCurrent__(current__, "setMailbox", Ice.OperationMode.Normal, context__)
                                    While True
                                        Dim direct__ As IceInternal.Direct = New IceInternal.Direct(current__)
                                        Dim servant__ As Object = direct__.servant()
                                        If TypeOf servant__ Is Participant Then
                                            Try
                                                CType(servant__, matt.roles.ParticipantOperations_).setMailbox(mb, current__)
                                                Return
                                            Catch ex__ As Ice.LocalException
                                                Throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                            Finally
                                                direct__.destroy()
                                            End Try
                                        Else
                                            direct__.destroy()
                                            Dim opEx__ As Ice.OperationNotExistException = new Ice.OperationNotExistException()
                                            opEx__.id = current__.id
                                            opEx__.facet = current__.facet
                                            opEx__.operation = current__.operation
                                            Throw opEx__
                                        End If
                                    End While
                                End Sub

                            End Class

                            Public NotInheritable class _MediatorDelD
                                Inherits Ice.ObjectDelD_
                                Implements _MediatorDel

                                Public Sub registerParticipant(ByVal p As matt.roles.ParticipantPrx, ByVal context__ As Ice.Context) Implements _MediatorDel.registerParticipant
                                    Dim current__ As Ice.Current = New Ice.Current
                                    initCurrent__(current__, "registerParticipant", Ice.OperationMode.Normal, context__)
                                    While True
                                        Dim direct__ As IceInternal.Direct = New IceInternal.Direct(current__)
                                        Dim servant__ As Object = direct__.servant()
                                        If TypeOf servant__ Is Mediator Then
                                            Try
                                                CType(servant__, matt.roles.MediatorOperations_).registerParticipant(p, current__)
                                                Return
                                            Catch ex__ As Ice.LocalException
                                                Throw New IceInternal.LocalExceptionWrapper(ex__, false)
                                            Finally
                                                direct__.destroy()
                                            End Try
                                        Else
                                            direct__.destroy()
                                            Dim opEx__ As Ice.OperationNotExistException = new Ice.OperationNotExistException()
                                            opEx__.id = current__.id
                                            opEx__.facet = current__.facet
                                            opEx__.operation = current__.operation
                                            Throw opEx__
                                        End If
                                    End While
                                End Sub

                            End Class

                        End Namespace

                    End Namespace

                    Namespace matt

                        Namespace messaging

                        End Namespace

                        Namespace roles

                        End Namespace

                    End Namespace
